#!/bin/sh

# test addfile

. tap.sh

fn=$(echo $$ $(date) | zpm hash -)

typetest() {
	res=$(zpm-stat -f '%t' "$1")
	okstreq "$res" "$2" "$1 is a $2"
}

ltypetest() {
	res=$(zpm-stat -l -f '%t' "$1")
	okstreq "$res" "$2" "$1 is a $2"
}

plan 18

file="/tmp/$fn"

# directory
tryrun mkdir $file
typetest $file directory
ltypetest $file directory
tryrun rmdir $file

#regular file
tryrun touch $file
typetest $file regular
ltypetest $file regular
size=$(zpm stat -f '%s' $file)
okstreq "$size" 0 'file size is zero'
echo foo > $file
size=$(zpm stat -f '%s' $file)
okstreq "$size" 4 'file foo size is four'


# symlink
require ln -s $file $file.symlink
typetest $file.symlink regular
ltypetest $file.symlink symlink
require rm $file.symlink
require rm $file

# fifo
require mkfifo $file
typetest $file fifo
require rm $file

# block and char specials probably require root to create
typetest /dev/null character

finish
